      subroutine check_cartgrad
C Check the gradient of Cartesian coordinates in internal coordinates.
      implicit none
      include 'DIMENSIONS'
      include 'COMMON.CONTROL'
      include 'COMMON.IOUNITS'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.GEO'
      include 'COMMON.LOCAL'
      include 'COMMON.DERIV'
      double precision temp(6,maxres),xx(3),gg(3),thet,theti,phii,alphi,
     & omegi,aincr2
      integer indmat
      integer i,ii,j,k
      indmat(i,j)=((2*(nres-2)-i)*(i-1))/2+j-1
      integer nf
*
* Check the gradient of the virtual-bond and SC vectors in the internal
* coordinates.
*    
      print '("Calling CHECK_ECART",1pd12.3)',aincr
      write (iout,'("Calling CHECK_ECART",1pd12.3)') aincr
      aincr2=0.5d0*aincr
      call chainbuild_extconf
      call cartder
      write (iout,'(a)') '**************** dx/dalpha'
      write (iout,'(a)')
      do i=2,nres-1
	alphi=alph(i)
	alph(i)=alph(i)+aincr
	do k=1,3
	  temp(k,i)=dc(k,nres+i)
        enddo
	call chainbuild_extconf
	do k=1,3
	  gg(k)=(dc(k,nres+i)-temp(k,i))/aincr
	  xx(k)=dabs((gg(k)-dxds(k,i))/(aincr*dabs(dxds(k,i))+aincr))
        enddo
        write (iout,'(i4,3e15.6/4x,3e15.6,3f9.3)') 
     &  i,(gg(k),k=1,3),(dxds(k,i),k=1,3),(xx(k),k=1,3)
        write (iout,'(a)')
	alph(i)=alphi
	call chainbuild_extconf
      enddo
      write (iout,'(a)')
      write (iout,'(a)') '**************** dx/domega'
      write (iout,'(a)')
      do i=2,nres-1
	omegi=omeg(i)
	omeg(i)=omeg(i)+aincr
	do k=1,3
	  temp(k,i)=dc(k,nres+i)
        enddo
	call chainbuild_extconf
	do k=1,3
          gg(k)=(dc(k,nres+i)-temp(k,i))/aincr
          xx(k)=dabs((gg(k)-dxds(k+3,i))/
     &          (aincr*dabs(dxds(k+3,i))+aincr))
        enddo
        write (iout,'(i4,3e15.6/4x,3e15.6,3f9.3)') 
     &      i,(gg(k),k=1,3),(dxds(k+3,i),k=1,3),(xx(k),k=1,3)
        write (iout,'(a)')
	omeg(i)=omegi
	call chainbuild_extconf
      enddo
      write (iout,'(a)')
      write (iout,'(a)') '**************** dx/dtheta'
      write (iout,'(a)')
      do i=3,nres
	theti=theta(i)
        theta(i)=theta(i)+aincr
        do j=i-1,nres-1
          do k=1,3
            temp(k,j)=dc(k,nres+j)
          enddo
        enddo
        call chainbuild_extconf
        do j=i-1,nres-1
	  ii = indmat(i-2,j)
c         print *,'i=',i-2,' j=',j-1,' ii=',ii
	  do k=1,3
	    gg(k)=(dc(k,nres+j)-temp(k,j))/aincr
	    xx(k)=dabs((gg(k)-dxdv(k,ii))/
     &            (aincr*dabs(dxdv(k,ii))+aincr))
          enddo
          write (iout,'(2i4,3e14.6/8x,3e14.6,3f9.3)') 
     &        i,j,(gg(k),k=1,3),(dxdv(k,ii),k=1,3),(xx(k),k=1,3)
          write(iout,'(a)')
        enddo
        write (iout,'(a)')
        theta(i)=theti
        call chainbuild_extconf
      enddo
      write (iout,'(a)') '***************** dx/dphi'
      write (iout,'(a)')
      do i=4,nres
        phi(i)=phi(i)+aincr
        do j=i-1,nres-1
          do k=1,3
            temp(k,j)=dc(k,nres+j)
          enddo
        enddo
        call chainbuild_extconf
        do j=i-1,nres-1
	  ii = indmat(i-2,j)
c         print *,'ii=',ii
	  do k=1,3
	    gg(k)=(dc(k,nres+j)-temp(k,j))/aincr
            xx(k)=dabs((gg(k)-dxdv(k+3,ii))/
     &            (aincr*dabs(dxdv(k+3,ii))+aincr))
          enddo
          write (iout,'(2i4,3e14.6/8x,3e14.6,3f9.3)') 
     &        i,j,(gg(k),k=1,3),(dxdv(k+3,ii),k=1,3),(xx(k),k=1,3)
          write(iout,'(a)')
        enddo
        phi(i)=phi(i)-aincr
        call chainbuild_extconf
      enddo
      write (iout,'(a)') '****************** ddc/dtheta'
      do i=1,nres-2
        thet=theta(i+2)
        theta(i+2)=thet+aincr
        do j=i,nres
          do k=1,3 
            temp(k,j)=dc(k,j)
          enddo
        enddo
        call chainbuild_extconf
        do j=i+1,nres-1
	  ii = indmat(i,j)
c         print *,'ii=',ii
	  do k=1,3
	    gg(k)=(dc(k,j)-temp(k,j))/aincr
	    xx(k)=dabs((gg(k)-dcdv(k,ii))/
     &           (aincr*dabs(dcdv(k,ii))+aincr))
          enddo
          write (iout,'(2i4,3e14.6/8x,3e14.6,3f9.3)') 
     &           i,j,(gg(k),k=1,3),(dcdv(k,ii),k=1,3),(xx(k),k=1,3)
	  write (iout,'(a)')
        enddo
        do j=1,nres
          do k=1,3
            dc(k,j)=temp(k,j)
          enddo 
        enddo
        theta(i+2)=thet
      enddo    
      write (iout,'(a)') '******************* ddc/dphi'
      do i=1,nres-3
        phii=phi(i+3)
        phi(i+3)=phii+aincr
        do j=1,nres
          do k=1,3 
            temp(k,j)=dc(k,j)
          enddo
        enddo
        call chainbuild_extconf 
        do j=i+2,nres-1
	  ii = indmat(i+1,j)
c         print *,'ii=',ii
	  do k=1,3
	    gg(k)=(dc(k,j)-temp(k,j))/aincr
            xx(k)=dabs((gg(k)-dcdv(k+3,ii))/
     &           (aincr*dabs(dcdv(k+3,ii))+aincr))
          enddo
          write (iout,'(2i4,3e14.6/8x,3e14.6,3f9.3)') 
     &         i,j,(gg(k),k=1,3),(dcdv(k+3,ii),k=1,3),(xx(k),k=1,3)
	  write (iout,'(a)')
        enddo
        do j=1,nres
          do k=1,3
            dc(k,j)=temp(k,j)
          enddo
        enddo
        phi(i+3)=phii   
      enddo   
      return
      end
