      implicit none
      double precision mytschebyshev
      integer n,i
      double precision x(3),dihedral,angle1,angle2,y,yt,deg2rad,aux,
     & czub,fy,fyt,fynum,fytnum,delta
      deg2rad = 4*datan(1.0d0)/180
      print *,"deg2rad",deg2rad
      read(*,*) n,dihedral,angle1,angle2,(x(i),i=1,n)
      yt=dsin(angle1*deg2rad)*dsin(angle2*deg2rad)
      y=dcos(dihedral*deg2rad)*yt
      aux=0.0d0
      do i=1,n
        aux=aux+x(i)*dcos(i*dihedral*deg2rad)*
     &      (dsin(angle1*deg2rad)*dsin(angle2*deg2rad))**i
        print *,x(i),aux
      enddo
      print *,"yt",yt," y",y
      czub=mytschebyshev(1,n,x,y,yt)
      print *,"term",czub," cos",aux
      delta=1.0d-5
      call mygradtschebyshev(1,n,x,y,yt,fy,fyt)
      fynum=(mytschebyshev(1,n,x,y+delta,yt)-mytschebyshev(1,n,x,y,yt))
     & /delta
      fytnum=(mytschebyshev(1,n,x,y,yt+delta)-mytschebyshev(1,n,x,y,yt))
     & /delta
      print *,"fy",fy," fynum",fynum," fyt",fyt," fytnum",fytnum
      end
c------------------------------------------------------------------------------
      double precision function mytschebyshev(m,n,x,y,yt)
      implicit none
      include "DIMENSIONS"
      integer i,m,n
      double precision x(n),y,yt,yy(0:maxvar),aux
c Tschebyshev polynomial in y multiplied by sin(t1)sin(t2) (yt). 
c Note that the first term is omitted
c m=0: the constant term is included
c m=1: the constant term is not included
      yy(0)=1.0d0
      yy(1)=y
      do i=2,n
        yy(i)=2*yy(1)*yy(i-1)-yy(i-2)*yt*yt
      enddo
      aux=0.0d0
      do i=m,n
        aux=aux+x(i)*yy(i)
      enddo
c      print *,(yy(i),i=1,n)
      mytschebyshev=aux
      return
      end
C--------------------------------------------------------------------------
      subroutine mygradtschebyshev(m,n,x,y,yt,fy,fyt)
      implicit none
      include "DIMENSIONS"
      integer i,m,n
      double precision x(n+1),y,yt,fy,fyt,yy(0:maxvar),yb(0:maxvar),
     & ybt(0:maxvar)
c Derivative of Tschebyshev polynomial in y multiplied by sin(t1)sin(t2) (yt). 
c Note that the first term is omitted
c m=0: the constant term is included
c m=1: the constant term is not included
      yy(0)=1.0d0
      yy(1)=y
      yb(0)=0.0d0
      yb(1)=1.0d0
      ybt(0)=0.0d0
      ybt(1)=0.0d0
      do i=2,n
        yy(i)=2*yy(1)*yy(i-1)-yy(i-2)*yt*yt
        yb(i)=2*yy(i-1)+2*yy(1)*yb(i-1)-yb(i-2)*yt*yt
        ybt(i)=2*yy(1)*ybt(i-1)-ybt(i-2)*yt*yt-2*yy(i-2)*yt
      enddo
      fy=0.0d0
      fyt=0.0d0
      do i=m,n
        fy=fy+x(i)*yb(i)
        fyt=fyt+x(i)*ybt(i)
      enddo
      return
      end 

